#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    SimpleWidget = new QWidget(this);
    IngWidget = new QWidget(this);
    HeaderWidget = new QWidget(this);

    setMaximumSize(400,550);
    setMinimumSize(400,550);

    MainWidget = new QWidget(this);

    SimpleInterface();
    IngInterface();
    HeaderInterface();

    SimpleCalcButton->setChecked(true);

    //SpawnSimpleCalc();

    counter_dot = false;

    save_nulls = 0;
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::SimpleInterface()
{

    QPushButton* pb_0 = new QPushButton("0",this);
    QPushButton* pb_1 = new QPushButton("1",this);
    QPushButton *pb_2 = new QPushButton("2", this);
    QPushButton *pb_3 = new QPushButton("3", this);
    QPushButton *pb_4 = new QPushButton("4", this);
    QPushButton *pb_5 = new QPushButton("5", this);
    QPushButton *pb_6 = new QPushButton("6", this);
    QPushButton *pb_7 = new QPushButton("7", this);
    QPushButton *pb_8 = new QPushButton("8", this);
    QPushButton *pb_9 = new QPushButton("9", this);
    QPushButton *pb_Dot = new QPushButton(".", this);
    QPushButton *pb_Plus = new QPushButton("+", this);
    QPushButton *pb_Minus = new QPushButton("-", this);
    QPushButton *pb_Divide = new QPushButton("/", this);
    QPushButton *pb_Mult = new QPushButton("*", this);
    QPushButton *pb_Equal = new QPushButton("=", this);
    QPushButton *pb_Sqrt = new QPushButton("\u221A", this);
    QPushButton *pb_Invert = new QPushButton("1 / x", this);

    pb_0->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_1->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_2->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_3->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_4->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_5->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_6->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_7->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_8->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_9->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Dot->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Plus->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Minus->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Divide->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Mult->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Equal->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Sqrt->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_Invert->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);

    QGridLayout* SimpleLayout = new QGridLayout(this);
    SimpleLayout->setSpacing(2);
    SimpleLayout->setContentsMargins(10,10,10,10);

    SimpleLayout->addWidget(pb_0,3,0,1,2);
    SimpleLayout->addWidget(pb_1,      2, 0);
    SimpleLayout->addWidget(pb_2,      2, 1);
    SimpleLayout->addWidget(pb_3,      2, 2);
    SimpleLayout->addWidget(pb_4,      1, 0);
    SimpleLayout->addWidget(pb_5,      1, 1);
    SimpleLayout->addWidget(pb_6,      1, 2);
    SimpleLayout->addWidget(pb_7,      0, 0);
    SimpleLayout->addWidget(pb_8,      0, 1);
    SimpleLayout->addWidget(pb_9,      0, 2);
    SimpleLayout->addWidget(pb_Dot,    3, 2);
    SimpleLayout->addWidget(pb_Plus,   3, 3);
    SimpleLayout->addWidget(pb_Minus,  2, 3);
    SimpleLayout->addWidget(pb_Divide, 0, 3);
    SimpleLayout->addWidget(pb_Mult,   1, 3);
    SimpleLayout->addWidget(pb_Equal,  2, 4, 2, 1);
    SimpleLayout->addWidget(pb_Sqrt,   0, 4);
    SimpleLayout->addWidget(pb_Invert, 1, 4);

    SimpleWidget->setLayout(SimpleLayout);

    connect(pb_0,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_1,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_2,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_3,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_4,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_5,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_6,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_7,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_8,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_9,SIGNAL(clicked()),SLOT(PushNumber()));
    connect(pb_Dot,SIGNAL(clicked()),SLOT(PushDot()));
    connect(pb_Plus,SIGNAL(clicked()),SLOT(PushBinary()));
    connect(pb_Minus,SIGNAL(clicked()),SLOT(PushBinary()));
    connect(pb_Mult,SIGNAL(clicked()),SLOT(PushBinary()));
    connect(pb_Equal,SIGNAL(clicked()),SLOT(PushEqual()));
    connect(pb_Sqrt,SIGNAL(clicked()),SLOT(PushUnary()));
    connect(pb_Invert,SIGNAL(clicked()),SLOT(PushUnary()));
    connect(pb_Divide,SIGNAL(clicked()),SLOT(PushBinary()));
}

void MainWindow::IngInterface()
{
    QPushButton *pb_sin = new QPushButton("sin", this);
    QPushButton *pb_cos = new QPushButton("cos", this);
    QPushButton *pb_tg = new QPushButton("tan", this);
    QPushButton *pb_exp = new QPushButton("exp", this);
    QPushButton *pb_ln = new QPushButton("ln", this);
    QPushButton *pb_log = new QPushButton("log", this);
    QPushButton *pb_st2 = new QPushButton("x\u00B2", this);
    QPushButton *pb_st3 = new QPushButton("x\u00B3", this);
    QPushButton *pb_st_y = new QPushButton("x\u207F", this);
    QPushButton *pb_rt3 = new QPushButton("\u00B3\u221A", this);
    QPushButton *pb_rt_y = new QPushButton("\u207F\u221A", this);
    QPushButton *pb_pi = new QPushButton("\u03C0", this);
    QPushButton *pb_fac = new QPushButton("n!", this);
    QPushButton *pb_sinh = new QPushButton("sinh", this);
    QPushButton *pb_cosh = new QPushButton("cosh", this);
    QPushButton *pb_tgh = new QPushButton("tanh", this);

    pb_sin->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_cos->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_tg->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_exp->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_ln->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_log->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_st2->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_st3->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_st_y->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_rt3->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_rt_y->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_pi->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_fac->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_sinh->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_cosh->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);
    pb_tgh->setSizePolicy(     QSizePolicy::Preferred, QSizePolicy::Preferred);

    QGridLayout* IngLayout = new QGridLayout(this);
    IngLayout->setSpacing(4);
    IngLayout->setContentsMargins(10,10,10,10);

    IngLayout->addWidget(pb_sin,      0, 1);
    IngLayout->addWidget(pb_cos,      1, 1);
    IngLayout->addWidget(pb_tg,      2, 1);
    IngLayout->addWidget(pb_exp,      0, 2);
    IngLayout->addWidget(pb_ln,      1, 2);
    IngLayout->addWidget(pb_log,      2, 2);
    IngLayout->addWidget(pb_st2,      0, 3);
    IngLayout->addWidget(pb_st3,      1, 3);
    IngLayout->addWidget(pb_st_y,      2, 3);
    IngLayout->addWidget(pb_rt3,      3, 2);
    IngLayout->addWidget(pb_rt_y,    3, 3);
    IngLayout->addWidget(pb_pi,   3, 1);
    IngLayout->addWidget(pb_fac,  3, 0);
    IngLayout->addWidget(pb_sinh, 0, 0);
    IngLayout->addWidget(pb_cosh,   1, 0);
    IngLayout->addWidget(pb_tgh,  2, 0);

    IngWidget->setLayout(IngLayout);

    connect(pb_sin, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_cos, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_tg, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_exp, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_ln, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_log, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_st2, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_st3, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_st_y, SIGNAL(clicked()), SLOT(PushBinary()));
    connect(pb_rt3, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_rt_y, SIGNAL(clicked()), SLOT(PushBinary()));
    connect(pb_pi, SIGNAL(clicked()), SLOT(PushNumber()));
    connect(pb_fac, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_sinh, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_cosh, SIGNAL(clicked()), SLOT(PushUnary()));
    connect(pb_tgh, SIGNAL(clicked()), SLOT(PushUnary()));
}

void MainWindow::HeaderInterface()
{
    QPushButton* clear = new QPushButton("C",this);

    lcd = new QLCDNumber(20,this);
    lcd->setSegmentStyle(QLCDNumber::Flat);

    SimpleCalcButton = new QRadioButton("Обычный калькулятор",this);
    IngCalcButton = new QRadioButton("Инженерный калькулятор",this);

    clear->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
    lcd->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
    SimpleCalcButton->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
    IngCalcButton->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);

    QGridLayout* HeaderLayout = new QGridLayout(this);

    HeaderLayout->setSpacing(4);
    HeaderLayout->setContentsMargins(10,10,10,10);

    HeaderLayout->addWidget(lcd,0,0,2,5);
    HeaderLayout->addWidget(SimpleCalcButton,2,0,1,4);
    HeaderLayout->addWidget(IngCalcButton,3,0,1,4);
    HeaderLayout->addWidget(clear,2,4,2,1);

    HeaderWidget = new QWidget(this);
    HeaderWidget->setLayout(HeaderLayout);

    connect(clear, SIGNAL(clicked()),SLOT(PushNumber()));
    connect(SimpleCalcButton, SIGNAL(toggled(bool)),SLOT(PushRadioButton()));
}

void MainWindow::SpawnSimpleCalc()
{
    IngWidget->hide();

    layout = new QGridLayout(this);

    layout->setSpacing(4);
    layout->setContentsMargins(10,10,10,10);

    layout->addWidget(HeaderWidget,0,0,1,1);
    layout->addWidget(SimpleWidget,1,0,2,1);

    MainWidget->setLayout(layout);

    setCentralWidget(MainWidget);

    //centralWidget()->setLayout(layout);

}

void MainWindow::SpawnIngCalc()
{
    IngWidget->show();

    layout = new QGridLayout(this);

    layout->setSpacing(4);
    layout->setContentsMargins(10,10,10,10);

    layout->addWidget(HeaderWidget,0,0,1,2);
    layout->addWidget(SimpleWidget,1,1,2,1);
    layout->addWidget(IngWidget,1,0,2,1);

    setCentralWidget(MainWidget);

    centralWidget()->setLayout(layout);
}

void MainWindow::PushRadioButton()
{
    if(SimpleCalcButton->isChecked())
    {
        delete layout;
        setMinimumSize(400,550);
        setMaximumSize(400,550);

        SpawnSimpleCalc();

        lcd->setDigitCount(20);
        setWindowTitle("Калькулятор обычный");
    }
    else
    {
        delete layout;

        setMinimumSize(800,550);
        setMaximumSize(800,550);

        SpawnIngCalc();

        lcd->setDigitCount(40);
        setWindowTitle("Калькулятор инженерный");
    }
}

void MainWindow::PushNumber()
{
    QPushButton* but = qobject_cast<QPushButton*>(sender());
    if(but == nullptr)
        return;
    //!!! Нет проверки успешности приведения. sender не обязательно QPushButton
    
        QString str = but->text();
        if(str == "C")
        {
            lcd->display(0);
            str_for_binary_op = nullptr;
            counter_dot = false;
            save_nulls = 0;
        }
        else
        {
            if(str == "\u03C0")
            {
                str_for_binary_op.clear();
                save_nulls = 0;
                counter_dot = false;
                lcd->display(3.141592653589793);
            }
            else
                {
                    QString str_front = QString::number(lcd->value());
                    if((str_front == "0" || str_front.isNull()) && !counter_dot)
                        lcd->display(str);
                    else
                    {
                        if(str_front != "0" && !str_front.isNull() && !counter_dot)
                            lcd->display((str_front + str));
                        else
                        {
                            if(str_front != "0" && !str_front.isNull())
                            {
                                QString temp;
                                for(unsigned int i = 0; i < save_nulls; i++)
                                    temp += '0';
                                double i;
                                if(modf(str_front.toDouble(), &i) == 0)
                                {
                                    lcd->display(str_front + "." + temp + str);
                                    if(str == "0")
                                    {
                                        save_nulls++;
                                    }
                                    else
                                    {
                                        save_nulls = 0;
                                        counter_dot = true;
                                    }
                                }
                                else
                                {
                                    lcd->display(str_front + temp + str);
                                    if(str == "0")
                                    {
                                        save_nulls++;
                                    }
                                    else
                                    {
                                        save_nulls = 0;
                                        counter_dot = true;
                                    }
                                }
                            }
                            else
                            {
                                if((str_front == "0" || str_front.isNull()))
                                {
                                    QString temp = "0.";
                                    for(unsigned int i = 0; i < save_nulls; i++)
                                        temp += '0';
                                    lcd->display(temp + str);
                                    if(str == "0")
                                        save_nulls++;
                                    else
                                    {
                                        save_nulls = 0;
                                        counter_dot = true;
                                    }
                                }
                            }
                        }

                    }

                }
        }
}

void MainWindow::PushBinary()
{
    save_nulls = 0;
        counter_dot = false;
        if(str_for_binary_op.isNull())
        {
            QPushButton* but = qobject_cast<QPushButton*>(sender());
            
            if(!but)
                return;
            QString str = but->text();
            str_for_binary_op = QString::number(lcd->value()) + str;
            lcd->display(nullptr);
        }
    else
        {
            QPushButton* but = qobject_cast<QPushButton*>(sender());
            if(!but)
                return;
            QString str = but->text();
            MainWindow::PushEqual();
            str_for_binary_op = QString::number(lcd->value()) + str;
            lcd->display(nullptr);
        }

}

double MainWindow::factorial(int N)
{
    if(N < 0)
        return 0;
    if(N == .0)
        return 1;
    else
        return N * factorial(static_cast<int>(N - 1));
}

void MainWindow::PushUnary()
{
    QPushButton* temp = qobject_cast<QPushButton*>(sender());
    if(temp == nullptr)
        return;
    //!!! Нет проверки успешности приведения. sender не обязательно QPushButton

    QString str = temp->text();

    if(str == "sin")
            lcd->display(std::sin(lcd->value()));
        if(str == "cos")
            lcd->display(std::cos(lcd->value()));
        if(str == "tan")
            lcd->display(std::tan(lcd->value()));
        if(str == "exp")
            lcd->display(std::exp(lcd->value()));
        if(str == "ln")
        {
            double number = lcd->value();
            if(number > 0)
                lcd->display(std::log(number));
            else
                lcd->display("Error");
        }
        if(str == "log")
        {
            double number = lcd->value();
            if(number > 0)
                lcd->display(std::log10(number));
            else
                lcd->display("Error");
        }
        if(str == "x\u00B2")
            lcd->display(std::pow(lcd->value(),2));
        if(str == "x\u00B3")
            lcd->display(std::pow(lcd->value(),3));
        if(str == "x\u207F")
            lcd->display(std::pow(lcd->value(),2));
        if(str == "\u00B3\u221A")
            lcd->display(std::cbrt(lcd->value()));
        if(str == "n!")
            lcd->display(factorial(lcd->value()));
        if(str == "sinh")
            lcd->display(std::sinh(lcd->value()));
        if(str == "cosh")
            lcd->display(std::cosh(lcd->value()));
        if(str == "tanh")
            lcd->display(std::tanh(lcd->value()));
        if(str == "\u221A")
        {
            double number = lcd->value();
            if(number >= 0)
                lcd->display(std::sqrt(number));
            else
               lcd->display("Error");
        }
        if(str == "1 / x")
        {
             double number = lcd->value();
            if(number)
                lcd->display(1/number);
            else
                lcd->display("Error");
        }
}

void MainWindow::PushDot()
{
    double i;
    modf(lcd->value(), &i);

    if(!counter_dot && modf(lcd->value(), &i) == 0)
    {
        lcd->display(QString::QString::number(lcd->value()) + ".");
        counter_dot = true;
    }
}

void MainWindow::PushEqual()
{
    save_nulls = 0;
    str_for_binary_op += QString::number(lcd->value());

    QString search_str = QString::fromStdString(str_for_binary_op.toStdString().substr(1));

    if(search_str.contains('+'))
    {
       QStringList str = str_for_binary_op.split('+');
       QString number_1 = str.at(0);
       QString number_2 = str.at(1);
       lcd->display(number_1.toDouble() + number_2.toDouble());
    }
    else
        {
            if(search_str.contains('-'))
            {
               QStringList str = str_for_binary_op.split('-');
               QString number_1 = str.at(0);
               QString number_2 = str.at(1);
               lcd->display(number_1.toDouble() - number_2.toDouble());
            }
            else
            {
                if(search_str.contains('*'))
                {
                   QStringList str = str_for_binary_op.split('*');
                   QString number_1 = str.at(0);
                   QString number_2 = str.at(1);
                   lcd->display(number_1.toDouble() * number_2.toDouble());
                }
                else
                {
                    if(search_str.contains('/'))
                    {
                       QStringList str = str_for_binary_op.split('/');
                       QString number_1 = str.at(0);
                       QString number_2 = str.at(1);
                       if(number_2 != "0")
                           lcd->display(number_1.toDouble() / number_2.toDouble());
                       else
                           lcd->display("Error");
                    }
                    else
                    {
                        if(search_str.contains("x\u207F"))
                        {
                            QStringList str = str_for_binary_op.split("x\u207F");
                            QString number_1 = str.at(0);
                            QString number_2 = str.at(1);
                            lcd->display(std::pow(number_1.toDouble(), number_2.toDouble()));
                        }
    else
                        {
                            if(search_str.contains("\u207F\u221A"))
                            {
                                QStringList str = str_for_binary_op.split("\u207F\u221A");
                                QString number_1 = str.at(0);
                                QString number_2 = str.at(1);
                                double result  = std::pow(number_1.toDouble(), 1/(number_2.toDouble()));
                                if(QString::number(result).contains(QRegExp("[0-9]")))
                                    lcd->display(result);
                                else
                                    lcd->display("Error");
                            }
                        }
                    }
                }
            }
        }
        str_for_binary_op.clear();
}















