#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QWidget>
#include <QGridLayout>
#include <QLCDNumber>
#include <QRadioButton>
#include <QPushButton>
#include <cmath>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private:
    Ui::MainWindow *ui;

    QWidget* MainWidget;
    QWidget* SimpleWidget;
    QWidget* IngWidget;
    QWidget* HeaderWidget;

    QGridLayout* layout;

    QLCDNumber* lcd;

    QRadioButton* SimpleCalcButton;
    QRadioButton* IngCalcButton;

    QString str_for_binary_op;

    bool counter_dot;
    unsigned int save_nulls;

private:

    void SimpleInterface();
    void IngInterface();
    void HeaderInterface();

    void SpawnSimpleCalc();
    void SpawnIngCalc();

    double factorial(int);

private slots:

    void PushNumber();
    void PushBinary();
    void PushUnary();
    void PushRadioButton();
    void PushDot();
    void PushEqual();

};
#endif // MAINWINDOW_H
